فهرست منبع

update todo, resolv conflict

Waldemar Brodkorb 14 سال پیش
والد
کامیت
b4c24c8ee4

+ 5 - 2
Makefile

@@ -4,7 +4,7 @@
 _UNLIMIT=	__limit=$$(ulimit -dH 2>/dev/null); \
 		test -n "$$__limit" && ulimit -dS $$__limit;
 
-all: .prereq_done
+all: checkreloc .prereq_done
 	@${_UNLIMIT} ${GMAKE_INV} all
 
 v: .prereq_done
@@ -224,4 +224,7 @@ NO_ERROR=0
 	@touch .adkinit
 	@touch $@
 
-.PHONY: prereq prereq-noerror
+checkreloc:
+	@bash scripts/reloc.sh
+
+.PHONY: prereq prereq-noerror checkreloc

+ 0 - 2
TODO

@@ -1,12 +1,10 @@
 - man pages in ipkg/tgz packages (automatic)
-- automatic healing after move of adk directory (pc,la)
 - ccache support for speedup
 - distcc evaluation
 - GCC SSP evaluation
 - LTO GCC evaluation
 - finish qemu package
 - fix autoreconf usage in opensc
-- fix timezone stuff in glibc
 - openssl ocf support check
 - locales support
 - new package minidlna

+ 0 - 1
mk/build.mk

@@ -14,7 +14,6 @@ DEFCONFIG=		ADK_DEBUG=n \
 			ADK_STATIC=n \
 			ADK_MAKE_PARALLEL=y \
 			ADK_MAKE_JOBS=4 \
-			ADK_PACKAGE_BZR=n \
 			ADK_PACKAGE_GRUB=n \
 			ADK_PACKAGE_BASE_FILES=y \
 			ADK_PACKAGE_MGETTY=n \

+ 0 - 1
mk/vars.mk

@@ -54,7 +54,6 @@ TARGET_DIR_PFX:=	$(BASE_DIR)/root_*
 TARGET_PATH=		${SCRIPT_DIR}:${TOOLS_DIR}:${STAGING_HOST_DIR}/bin:${STAGING_TARGET_DIR}/scripts:${_PATH}
 REAL_GNU_TARGET_NAME=	$(CPU_ARCH)-$(ADK_VENDOR)-linux-$(ADK_TARGET_SUFFIX)
 GNU_TARGET_NAME=	$(CPU_ARCH)-$(ADK_VENDOR)-linux
-TOOLCHAIN_SYSROOT:=	$(TOOLCHAIN_BUILD_DIR)/libc_dev
 ifeq ($(ADK_NATIVE),y) 
 TARGET_CROSS:=		
 TARGET_COMPILER_PREFIX?=

+ 8 - 6
package/bzr/Makefile

@@ -1,12 +1,12 @@
-# This file is part of the OpenADK project. OpenADK is copyrighted
+# This file is part of the OpenADK project. OpenADK is copyrighted 
 # material, please see the LICENCE file in the top-level directory.
 
 include $(TOPDIR)/rules.mk
 
 PKG_NAME:=		bzr
-PKG_VERSION:=		2.3b3
+PKG_VERSION:=		2.3b4
 PKG_RELEASE:=		1
-PKG_MD5SUM:=		94f9181b9a4ab84b94cfbc06bd5dfd91
+PKG_MD5SUM:=		62ba2dbd8b13745bc89e24dd4191cdc5
 PKG_DESCR:=		bazaar
 PKG_SECTION:=		scm
 PKG_DEPENDS:=		python2
@@ -25,11 +25,13 @@ INSTALL_STYLE:=		manual
 include $(TOPDIR)/mk/python.mk
 
 do-build:
-	cd $(WRKBUILD); env PYTHONPATH=$(PYTHON_LIBDIR) $(PYTHON) ./setup.py install --prefix="$(WRKINST)/usr"
+	cd $(WRKBUILD); env PYTHONPATH=$(PYTHON_LIBDIR) $(PYTHON) ./setup.py install --prefix=$(WRKINST)/usr build_ext --allow-python-fallback
 
 do-install:
+	$(INSTALL_DIR) $(IDIR_BZR)/usr/lib/python$(PYTHON_VERSION)/site-packages
+	$(CP) $(WRKINST)/usr/lib/python$(PYTHON_VERSION)/site-packages/* \
+		$(IDIR_BZR)/usr/lib/python$(PYTHON_VERSION)/site-packages
 	$(INSTALL_DIR) $(IDIR_BZR)/usr/bin
-	$(INSTALL_BIN) $(WRKINST)/usr/bin/bzr \
-		$(IDIR_BZR)/usr/bin
+	$(INSTALL_BIN) $(WRKINST)/usr/bin/bzr $(IDIR_BZR)/usr/bin
 
 include ${TOPDIR}/mk/pkg-bottom.mk

+ 16 - 3
package/glibc/Makefile

@@ -23,9 +23,22 @@ INSTALL_STYLE:=		manual
 # compile nothing, glibc is already build in toolchain directory
 do-install:
 	${INSTALL_DIR} $(IDIR_GLIBC)/lib $(IDIR_GLIBC)/etc
-	test -z $(ADK_RUNTIME_TIMEZONE) || \
-	   $(CP) /usr/share/zoneinfo/$(ADK_RUNTIME_TIMEZONE) \
-		$(IDIR_GLIBC)/etc/localtime
+	cd ${STAGING_TARGET_DIR} && for f in UTC ${ADK_RUNTIME_TIMEZONE}; do \
+		test -s usr/share/zoneinfo/"$$f" || continue; \
+		echo usr/share/zoneinfo/"$$f" | \
+		    ${TOOLS_DIR}/cpio -pdu ${IDIR_GLIBC}/; \
+	done
+	tz=; cd ${IDIR_GLIBC}/usr/share/zoneinfo || exit 1; \
+	    for f in UTC ${ADK_RUNTIME_TIMEZONE}; do \
+		test -s "$$f" || continue; \
+		tz=$$f; \
+	done; if test x"$$tz" = x""; then \
+		echo >&2 Error during timezone installation; \
+		exit 1; \
+	else \
+		ln -sf "../usr/share/zoneinfo/$$tz" \
+		    ${IDIR_GLIBC}/etc/localtime; \
+	fi
 	${CP} ${STAGING_TARGET_DIR}/etc/gai.conf ${IDIR_GLIBC}/etc/
 	${CP} ${STAGING_TARGET_DIR}/etc/nscd.conf ${IDIR_GLIBC}/etc/
 	${CP} ${STAGING_TARGET_DIR}/etc/nsswitch.conf ${IDIR_GLIBC}/etc/

+ 10 - 23
package/iproute2/Makefile

@@ -4,9 +4,9 @@
 include ${TOPDIR}/rules.mk
 
 PKG_NAME:=		iproute2
-PKG_VERSION:=		2.6.34
+PKG_VERSION:=		2.6.37
 PKG_RELEASE:=		1
-PKG_MD5SUM:=		5c5742bdac05a1688f266512e685b83c
+PKG_MD5SUM:=		9774ff9d74ebd301bf56bd8d74473786
 PKG_DESCR:=		iproute2 routing control utility
 PKG_SECTION:=		route
 PKG_URL:=		http://www.linuxfoundation.org/en/Net:Iproute2
@@ -44,55 +44,42 @@ XAKE_FLAGS+=		CCOPTS="${TCFLAGS}" MFLAGS="CC=${TARGET_CC}" \
 
 CONFIGURE_FLAGS+=	KERNEL_INCLUDE="${LINUX_DIR}/include"
 
-INSTALL_y:=
-INSTALL_m:=
-INSTALL_${ADK_PACKAGE_IP}+=	install-ip
-INSTALL_${ADK_PACKAGE_TC}+=	install-tc
-INSTALL_${ADK_PACKAGE_TC_ATM}+=	install-tc-atm
-INSTALL_${ADK_PACKAGE_IFSTAT}+=	install-ifstat
-INSTALL_${ADK_PACKAGE_LNSTAT}+=	install-lnstat
-INSTALL_${ADK_PACKAGE_ROUTEL}+=	install-routel
-INSTALL_${ADK_PACKAGE_RTMON}+=	install-rtmon
-INSTALL_${ADK_PACKAGE_SS}+=	install-ss
-
-post-install: ${INSTALL_y} ${INSTALL_m}
-
-install-ip:
+ip-install:
 	${INSTALL_DIR} ${IDIR_IP}/{etc/iproute2,usr/sbin}
 	${INSTALL_DATA} ${WRKINST}/etc/iproute2/* ${IDIR_IP}/etc/iproute2/
 	${INSTALL_BIN} ${WRKINST}/sbin/ip ${IDIR_IP}/usr/sbin/ip
 
-install-tc:
+tc-install:
 	${INSTALL_DIR} ${IDIR_TC}/{lib/tc,usr/sbin}
 	# use ${CP} here, since m_ipt.so is a symlink to m_xt.so
 	${CP} ${WRKINST}/lib/tc/{m_*.so,*.dist} ${IDIR_TC}/lib/tc/
 	${INSTALL_BIN} ${WRKINST}/sbin/tc ${IDIR_TC}/usr/sbin/
 
-install-tc-atm:
+tc-atm-install:
 	${INSTALL_DIR} ${IDIR_TC_ATM}/lib/tc
 	${INSTALL_DATA} ${WRKINST}/lib/tc/q_atm.so \
 		${IDIR_TC_ATM}/lib/tc/
 
-install-ifstat:
+ifstat-install:
 	${INSTALL_DIR} ${IDIR_IFSTAT}/usr/sbin
 	${INSTALL_BIN} ${WRKINST}/sbin/ifstat ${IDIR_IFSTAT}/usr/sbin
 
-install-lnstat:
+lnstat-install:
 	${INSTALL_DIR} ${IDIR_LNSTAT}/usr/sbin
 	${INSTALL_BIN} ${WRKINST}/sbin/{ln,n}stat ${IDIR_LNSTAT}/usr/sbin
 	ln -sf lnstat ${IDIR_LNSTAT}/usr/sbin/rtstat
 	ln -sf lnstat ${IDIR_LNSTAT}/usr/sbin/ctstat
 	${INSTALL_BIN} ${WRKINST}/sbin/rtacct ${IDIR_LNSTAT}/usr/sbin
 
-install-routel:
+routel-install:
 	${INSTALL_DIR} ${IDIR_ROUTEL}/usr/sbin
 	${INSTALL_BIN} ${WRKINST}/sbin/route{l,f} ${IDIR_ROUTEL}/usr/sbin
 
-install-rtmon:
+rtmon-install:
 	${INSTALL_DIR} ${IDIR_RTMON}/usr/sbin
 	${INSTALL_BIN} ${WRKINST}/sbin/rtmon ${IDIR_RTMON}/usr/sbin
 
-install-ss:
+ss-install:
 	${INSTALL_DIR} ${IDIR_SS}/usr/sbin
 	${INSTALL_BIN} ${WRKINST}/sbin/ss ${IDIR_SS}/usr/sbin
 

+ 1 - 0
package/libnl/Makefile

@@ -11,6 +11,7 @@ PKG_DESCR:=		Netlink library
 PKG_SECTION:=		libs
 PKG_URL:=		http://www.infradead.org/~tgr/libnl/
 PKG_SITES:=		http://www.infradead.org/~tgr/libnl/files/
+PKG_NOPARALLEL:=	1
 
 PKG_SUBPKGS:=		LIBNL LIBNL_DEV
 PKGSD_LIBNL_DEV:=	header files for netlink library

+ 7 - 3
package/python2/Makefile

@@ -9,10 +9,11 @@ PKG_RELEASE:=		1
 PKG_MD5SUM:=		15ed56733655e3fab785e49a7278d2fb
 PKG_DESCR:=		Python scripting language (Version 2)
 PKG_SECTION:=		lang
-PKG_DEPENDS:=		libpthread zlib libffi
-PKG_BUILDDEP:=		zlib libffi
+PKG_DEPENDS:=		libpthread zlib libffi libopenssl
+PKG_BUILDDEP:=		zlib libffi openssl
 PKG_URL:=		http://www.python.org/
 PKG_SITES:=		http://www.python.org/ftp/python/${PKG_VERSION}/
+PKG_OPTS:=		noscripts
 
 PKG_HOST_DEPENDS:=	!netbsd !openbsd !cygwin
 
@@ -21,7 +22,7 @@ WRKDIST=		${WRKDIR}/Python-${PKG_VERSION}
 
 include ${TOPDIR}/mk/package.mk
 
-$(eval $(call PKG_template,PYTHON2,${PKG_NAME},${PKG_VERSION}-${PKG_RELEASE},${PKG_DEPENDS},${PKG_DESCR},${PKG_SECTION}))
+$(eval $(call PKG_template,PYTHON2,${PKG_NAME},${PKG_VERSION}-${PKG_RELEASE},${PKG_DEPENDS},${PKG_DESCR},${PKG_SECTION},${PKG_OPTS}))
 
 MAKE_ENV+=		OPT="$(TARGET_CFLAGS)" \
 			RANLIB="${TARGET_CROSS}ranlib" \
@@ -61,5 +62,8 @@ post-install:
 	${CP} ${WRKINST}/usr/lib/python2.7/* ${IDIR_PYTHON2}/usr/lib/python2.7
 	${CP} ${WRKINST}/usr/include/python2.7/* ${IDIR_PYTHON2}/usr/include/python2.7
 	-find ${IDIR_PYTHON2} -name "\*.pyc" -o -name "*\.pyo" -exec rm {} \;
+	# workaround, copy host python-config to target scripts directory
+	${CP} ${STAGING_HOST_DIR}/bin/python*-config ${STAGING_TARGET_DIR}/scripts
+	${CP} ${STAGING_HOST_DIR}/bin/python*-config ${STAGING_TARGET_DIR}/usr/bin
 
 include ${TOPDIR}/mk/pkg-bottom.mk

+ 0 - 11
package/python2/patches/patch-Misc_python_pc

@@ -1,11 +0,0 @@
---- Python-2.7.1.orig/Misc/python.pc	2010-12-27 21:24:34.000000000 +0100
-+++ Python-2.7.1/Misc/python.pc	2010-12-27 21:07:05.000000000 +0100
-@@ -7,7 +7,7 @@ Name: Python
- Description: Python library
- Requires: 
- Version: 2.7
--Libs.private: -ldl  -framework CoreFoundation
-+Libs.private: -lpthread -ldl  -lpthread
- Libs: -L${libdir} -lpython2.7
- Cflags: -I${includedir}/python2.7 
- 

+ 0 - 521
package/python2/patches/patch-pyconfig_h

@@ -1,521 +0,0 @@
---- Python-2.7.1.orig/pyconfig.h	2010-12-27 21:24:34.000000000 +0100
-+++ Python-2.7.1/pyconfig.h	2010-12-27 21:07:05.000000000 +0100
-@@ -32,10 +32,10 @@
- 
- /* Define if C doubles are 64-bit IEEE 754 binary format, stored with the
-    least significant byte first */
--#define DOUBLE_IS_LITTLE_ENDIAN_IEEE754 1
-+/* #undef DOUBLE_IS_LITTLE_ENDIAN_IEEE754 */
- 
- /* Define if --enable-ipv6 is specified */
--#define ENABLE_IPV6 1
-+/* #undef ENABLE_IPV6 */
- 
- /* Define if flock needs to be linked with bsd library. */
- /* #undef FLOCK_NEEDS_LIBBSD */
-@@ -63,7 +63,7 @@
- #define HAVE_ASINH 1
- 
- /* Define to 1 if you have the <asm/types.h> header file. */
--/* #undef HAVE_ASM_TYPES_H */
-+#define HAVE_ASM_TYPES_H 1
- 
- /* Define to 1 if you have the `atanh' function. */
- #define HAVE_ATANH 1
-@@ -75,7 +75,7 @@
- /* #undef HAVE_BIND_TEXTDOMAIN_CODESET */
- 
- /* Define to 1 if you have the <bluetooth/bluetooth.h> header file. */
--/* #undef HAVE_BLUETOOTH_BLUETOOTH_H */
-+#define HAVE_BLUETOOTH_BLUETOOTH_H 1
- 
- /* Define to 1 if you have the <bluetooth.h> header file. */
- /* #undef HAVE_BLUETOOTH_H */
-@@ -126,7 +126,7 @@
- #define HAVE_CTERMID 1
- 
- /* Define if you have the 'ctermid_r' function. */
--#define HAVE_CTERMID_R 1
-+/* #undef HAVE_CTERMID_R */
- 
- /* Define to 1 if you have the <curses.h> header file. */
- #define HAVE_CURSES_H 1
-@@ -185,7 +185,7 @@
- #define HAVE_DYNAMIC_LOADING 1
- 
- /* Define if you have the 'epoll' functions. */
--/* #undef HAVE_EPOLL */
-+#define HAVE_EPOLL 1
- 
- /* Define to 1 if you have the `erf' function. */
- #define HAVE_ERF 1
-@@ -215,10 +215,10 @@
- #define HAVE_FCNTL_H 1
- 
- /* Define if you have the 'fdatasync' function. */
--/* #undef HAVE_FDATASYNC */
-+#define HAVE_FDATASYNC 1
- 
- /* Define to 1 if you have the `finite' function. */
--#define HAVE_FINITE 1
-+/* #undef HAVE_FINITE */
- 
- /* Define to 1 if you have the `flock' function. */
- #define HAVE_FLOCK 1
-@@ -227,7 +227,7 @@
- #define HAVE_FORK 1
- 
- /* Define to 1 if you have the `forkpty' function. */
--#define HAVE_FORKPTY 1
-+/* #undef HAVE_FORKPTY */
- 
- /* Define to 1 if you have the `fpathconf' function. */
- #define HAVE_FPATHCONF 1
-@@ -267,7 +267,7 @@
- #define HAVE_GCC_ASM_FOR_X87 1
- 
- /* Define if you have the getaddrinfo function. */
--#define HAVE_GETADDRINFO 1
-+/* #undef HAVE_GETADDRINFO */
- 
- /* Define to 1 if you have the `getcwd' function. */
- #define HAVE_GETCWD 1
-@@ -279,10 +279,10 @@
- #define HAVE_GETGROUPS 1
- 
- /* Define to 1 if you have the `gethostbyname' function. */
--#define HAVE_GETHOSTBYNAME 1
-+/* #undef HAVE_GETHOSTBYNAME */
- 
- /* Define this if you have some version of gethostbyname_r() */
--/* #undef HAVE_GETHOSTBYNAME_R */
-+#define HAVE_GETHOSTBYNAME_R 1
- 
- /* Define this if you have the 3-arg version of gethostbyname_r(). */
- /* #undef HAVE_GETHOSTBYNAME_R_3_ARG */
-@@ -291,13 +291,13 @@
- /* #undef HAVE_GETHOSTBYNAME_R_5_ARG */
- 
- /* Define this if you have the 6-arg version of gethostbyname_r(). */
--/* #undef HAVE_GETHOSTBYNAME_R_6_ARG */
-+#define HAVE_GETHOSTBYNAME_R_6_ARG 1
- 
- /* Define to 1 if you have the `getitimer' function. */
- #define HAVE_GETITIMER 1
- 
- /* Define to 1 if you have the `getloadavg' function. */
--#define HAVE_GETLOADAVG 1
-+/* #undef HAVE_GETLOADAVG */
- 
- /* Define to 1 if you have the `getlogin' function. */
- #define HAVE_GETLOGIN 1
-@@ -327,25 +327,25 @@
- #define HAVE_GETPWENT 1
- 
- /* Define to 1 if you have the `getresgid' function. */
--/* #undef HAVE_GETRESGID */
-+#define HAVE_GETRESGID 1
- 
- /* Define to 1 if you have the `getresuid' function. */
--/* #undef HAVE_GETRESUID */
-+#define HAVE_GETRESUID 1
- 
- /* Define to 1 if you have the `getsid' function. */
- #define HAVE_GETSID 1
- 
- /* Define to 1 if you have the `getspent' function. */
--/* #undef HAVE_GETSPENT */
-+#define HAVE_GETSPENT 1
- 
- /* Define to 1 if you have the `getspnam' function. */
--/* #undef HAVE_GETSPNAM */
-+#define HAVE_GETSPNAM 1
- 
- /* Define to 1 if you have the `gettimeofday' function. */
- #define HAVE_GETTIMEOFDAY 1
- 
- /* Define to 1 if you have the `getwd' function. */
--#define HAVE_GETWD 1
-+/* #undef HAVE_GETWD */
- 
- /* Define to 1 if you have the <grp.h> header file. */
- #define HAVE_GRP_H 1
-@@ -381,7 +381,7 @@
- #define HAVE_KILLPG 1
- 
- /* Define if you have the 'kqueue' functions. */
--#define HAVE_KQUEUE 1
-+/* #undef HAVE_KQUEUE */
- 
- /* Define to 1 if you have the <langinfo.h> header file. */
- #define HAVE_LANGINFO_H 1
-@@ -390,13 +390,13 @@
-    and long long is available and at least as big as an off_t. You may need to
-    add some flags for configuration and compilation to enable this mode. (For
-    Solaris and Linux, the necessary defines are already defined.) */
--/* #undef HAVE_LARGEFILE_SUPPORT */
-+#define HAVE_LARGEFILE_SUPPORT 1
- 
- /* Define to 1 if you have the `lchflags' function. */
- /* #undef HAVE_LCHFLAGS */
- 
- /* Define to 1 if you have the `lchmod' function. */
--#define HAVE_LCHMOD 1
-+/* #undef HAVE_LCHMOD */
- 
- /* Define to 1 if you have the `lchown' function. */
- #define HAVE_LCHOWN 1
-@@ -414,7 +414,7 @@
- /* #undef HAVE_LIBIEEE */
- 
- /* Define to 1 if you have the <libintl.h> header file. */
--/* #undef HAVE_LIBINTL_H */
-+#define HAVE_LIBINTL_H 1
- 
- /* Define if you have the readline library (-lreadline). */
- #define HAVE_LIBREADLINE 1
-@@ -429,10 +429,10 @@
- #define HAVE_LINK 1
- 
- /* Define to 1 if you have the <linux/netlink.h> header file. */
--/* #undef HAVE_LINUX_NETLINK_H */
-+#define HAVE_LINUX_NETLINK_H 1
- 
- /* Define to 1 if you have the <linux/tipc.h> header file. */
--/* #undef HAVE_LINUX_TIPC_H */
-+#define HAVE_LINUX_TIPC_H 1
- 
- /* Define to 1 if you have the `log1p' function. */
- #define HAVE_LOG1P 1
-@@ -465,7 +465,7 @@
- #define HAVE_MKTIME 1
- 
- /* Define to 1 if you have the `mremap' function. */
--/* #undef HAVE_MREMAP */
-+#define HAVE_MREMAP 1
- 
- /* Define to 1 if you have the <ncurses.h> header file. */
- #define HAVE_NCURSES_H 1
-@@ -474,16 +474,16 @@
- /* #undef HAVE_NDIR_H */
- 
- /* Define to 1 if you have the <netpacket/packet.h> header file. */
--/* #undef HAVE_NETPACKET_PACKET_H */
-+#define HAVE_NETPACKET_PACKET_H 1
- 
- /* Define to 1 if you have the `nice' function. */
- #define HAVE_NICE 1
- 
- /* Define to 1 if you have the `openpty' function. */
--#define HAVE_OPENPTY 1
-+/* #undef HAVE_OPENPTY */
- 
- /* Define if compiling using MacOS X 10.5 SDK or later. */
--#define HAVE_OSX105_SDK 1
-+/* #undef HAVE_OSX105_SDK */
- 
- /* Define to 1 if you have the `pathconf' function. */
- #define HAVE_PATHCONF 1
-@@ -519,10 +519,10 @@
- /* #undef HAVE_PTHREAD_INIT */
- 
- /* Define to 1 if you have the `pthread_sigmask' function. */
--/* #undef HAVE_PTHREAD_SIGMASK */
-+#define HAVE_PTHREAD_SIGMASK 1
- 
- /* Define to 1 if you have the <pty.h> header file. */
--/* #undef HAVE_PTY_H */
-+#define HAVE_PTY_H 1
- 
- /* Define to 1 if you have the `putenv' function. */
- #define HAVE_PUTENV 1
-@@ -537,7 +537,7 @@
- #define HAVE_RL_CALLBACK 1
- 
- /* Define if you can turn off readline's signal handling. */
--/* #undef HAVE_RL_CATCH_SIGNAL */
-+#define HAVE_RL_CATCH_SIGNAL 1
- 
- /* Define if you have readline 2.2 */
- #define HAVE_RL_COMPLETION_APPEND_CHARACTER 1
-@@ -549,7 +549,7 @@
- #define HAVE_RL_COMPLETION_MATCHES 1
- 
- /* Define if you have rl_completion_suppress_append */
--/* #undef HAVE_RL_COMPLETION_SUPPRESS_APPEND */
-+#define HAVE_RL_COMPLETION_SUPPRESS_APPEND 1
- 
- /* Define if you have readline 4.0 */
- #define HAVE_RL_PRE_INPUT_HOOK 1
-@@ -567,7 +567,7 @@
- #define HAVE_SEM_OPEN 1
- 
- /* Define to 1 if you have the `sem_timedwait' function. */
--/* #undef HAVE_SEM_TIMEDWAIT */
-+#define HAVE_SEM_TIMEDWAIT 1
- 
- /* Define to 1 if you have the `sem_unlink' function. */
- #define HAVE_SEM_UNLINK 1
-@@ -600,10 +600,10 @@
- #define HAVE_SETREGID 1
- 
- /* Define to 1 if you have the `setresgid' function. */
--/* #undef HAVE_SETRESGID */
-+#define HAVE_SETRESGID 1
- 
- /* Define to 1 if you have the `setresuid' function. */
--/* #undef HAVE_SETRESUID */
-+#define HAVE_SETRESUID 1
- 
- /* Define to 1 if you have the `setreuid' function. */
- #define HAVE_SETREUID 1
-@@ -618,7 +618,7 @@
- #define HAVE_SETVBUF 1
- 
- /* Define to 1 if you have the <shadow.h> header file. */
--/* #undef HAVE_SHADOW_H */
-+#define HAVE_SHADOW_H 1
- 
- /* Define to 1 if you have the `sigaction' function. */
- #define HAVE_SIGACTION 1
-@@ -630,13 +630,13 @@
- #define HAVE_SIGNAL_H 1
- 
- /* Define to 1 if you have the `sigrelse' function. */
--#define HAVE_SIGRELSE 1
-+/* #undef HAVE_SIGRELSE */
- 
- /* Define to 1 if you have the `snprintf' function. */
- #define HAVE_SNPRINTF 1
- 
- /* Define if sockaddr has sa_len member */
--#define HAVE_SOCKADDR_SA_LEN 1
-+/* #undef HAVE_SOCKADDR_SA_LEN */
- 
- /* struct sockaddr_storage (sys/socket.h) */
- #define HAVE_SOCKADDR_STORAGE 1
-@@ -645,7 +645,7 @@
- #define HAVE_SOCKETPAIR 1
- 
- /* Define to 1 if you have the <spawn.h> header file. */
--#define HAVE_SPAWN_H 1
-+/* #undef HAVE_SPAWN_H */
- 
- /* Define if your compiler provides ssize_t */
- #define HAVE_SSIZE_T 1
-@@ -654,10 +654,10 @@
- #define HAVE_STATVFS 1
- 
- /* Define if you have struct stat.st_mtim.tv_nsec */
--/* #undef HAVE_STAT_TV_NSEC */
-+#define HAVE_STAT_TV_NSEC 1
- 
- /* Define if you have struct stat.st_mtimensec */
--#define HAVE_STAT_TV_NSEC2 1
-+/* #undef HAVE_STAT_TV_NSEC2 */
- 
- /* Define if your compiler supports variable length function prototypes (e.g.
-    void fprintf(FILE *, char *, ...);) *and* <stdarg.h> */
-@@ -694,10 +694,10 @@
- #define HAVE_STRUCT_STAT_ST_BLOCKS 1
- 
- /* Define to 1 if `st_flags' is a member of `struct stat'. */
--#define HAVE_STRUCT_STAT_ST_FLAGS 1
-+/* #undef HAVE_STRUCT_STAT_ST_FLAGS */
- 
- /* Define to 1 if `st_gen' is a member of `struct stat'. */
--#define HAVE_STRUCT_STAT_ST_GEN 1
-+/* #undef HAVE_STRUCT_STAT_ST_GEN */
- 
- /* Define to 1 if `st_rdev' is a member of `struct stat'. */
- #define HAVE_STRUCT_STAT_ST_RDEV 1
-@@ -729,10 +729,10 @@
- /* #undef HAVE_SYS_DIR_H */
- 
- /* Define to 1 if you have the <sys/epoll.h> header file. */
--/* #undef HAVE_SYS_EPOLL_H */
-+#define HAVE_SYS_EPOLL_H 1
- 
- /* Define to 1 if you have the <sys/event.h> header file. */
--#define HAVE_SYS_EVENT_H 1
-+/* #undef HAVE_SYS_EVENT_H */
- 
- /* Define to 1 if you have the <sys/file.h> header file. */
- #define HAVE_SYS_FILE_H 1
-@@ -741,7 +741,7 @@
- /* #undef HAVE_SYS_LOADAVG_H */
- 
- /* Define to 1 if you have the <sys/lock.h> header file. */
--#define HAVE_SYS_LOCK_H 1
-+/* #undef HAVE_SYS_LOCK_H */
- 
- /* Define to 1 if you have the <sys/mkdev.h> header file. */
- /* #undef HAVE_SYS_MKDEV_H */
-@@ -829,7 +829,7 @@
- #define HAVE_TMPNAM 1
- 
- /* Define to 1 if you have the `tmpnam_r' function. */
--/* #undef HAVE_TMPNAM_R */
-+#define HAVE_TMPNAM_R 1
- 
- /* Define to 1 if your `struct tm' has `tm_zone'. Deprecated, use
-    `HAVE_STRUCT_TM_TM_ZONE' instead. */
-@@ -863,7 +863,7 @@
- /* #undef HAVE_USABLE_WCHAR_T */
- 
- /* Define to 1 if you have the <util.h> header file. */
--#define HAVE_UTIL_H 1
-+/* #undef HAVE_UTIL_H */
- 
- /* Define to 1 if you have the `utimes' function. */
- #define HAVE_UTIMES 1
-@@ -888,7 +888,7 @@
- 
- /* Define if tzset() actually switches the local timezone in a meaningful way.
-    */
--#define HAVE_WORKING_TZSET 1
-+/* #undef HAVE_WORKING_TZSET */
- 
- /* Define if the zlib library has inflateCopy */
- #define HAVE_ZLIB_COPY 1
-@@ -953,7 +953,7 @@
- /* #undef Py_DEBUG */
- 
- /* Defined if Python is built as a shared library. */
--/* #undef Py_ENABLE_SHARED */
-+#define Py_ENABLE_SHARED 1
- 
- /* Define as the size of the unicode type. */
- #define Py_UNICODE_SIZE 2
-@@ -980,16 +980,16 @@
- #define SIZEOF_FLOAT 4
- 
- /* The size of `fpos_t', as computed by sizeof. */
--#define SIZEOF_FPOS_T 8
-+#define SIZEOF_FPOS_T 20
- 
- /* The size of `int', as computed by sizeof. */
- #define SIZEOF_INT 4
- 
- /* The size of `long', as computed by sizeof. */
--#define SIZEOF_LONG 8
-+#define SIZEOF_LONG 4
- 
- /* The size of `long double', as computed by sizeof. */
--#define SIZEOF_LONG_DOUBLE 16
-+#define SIZEOF_LONG_DOUBLE 12
- 
- /* The size of `long long', as computed by sizeof. */
- #define SIZEOF_LONG_LONG 8
-@@ -1001,22 +1001,22 @@
- #define SIZEOF_PID_T 4
- 
- /* The size of `pthread_t', as computed by sizeof. */
--#define SIZEOF_PTHREAD_T 8
-+#define SIZEOF_PTHREAD_T 4
- 
- /* The size of `short', as computed by sizeof. */
- #define SIZEOF_SHORT 2
- 
- /* The size of `size_t', as computed by sizeof. */
--#define SIZEOF_SIZE_T 8
-+#define SIZEOF_SIZE_T 4
- 
- /* The size of `time_t', as computed by sizeof. */
--#define SIZEOF_TIME_T 8
-+#define SIZEOF_TIME_T 4
- 
- /* The size of `uintptr_t', as computed by sizeof. */
--#define SIZEOF_UINTPTR_T 8
-+#define SIZEOF_UINTPTR_T 4
- 
- /* The size of `void *', as computed by sizeof. */
--#define SIZEOF_VOID_P 8
-+#define SIZEOF_VOID_P 4
- 
- /* The size of `wchar_t', as computed by sizeof. */
- #define SIZEOF_WCHAR_T 4
-@@ -1032,7 +1032,7 @@
- #define SYS_SELECT_WITH_SYS_TIME 1
- 
- /* Define if tanh(-0.) is -0., or if platform doesn't have signed zeros */
--#define TANH_PRESERVES_ZERO_SIGN 1
-+/* #undef TANH_PRESERVES_ZERO_SIGN */
- 
- /* Define to 1 if you can safely include both <sys/time.h> and <time.h>. */
- #define TIME_WITH_SYS_TIME 1
-@@ -1063,10 +1063,10 @@
- 
- 
- /* Define if you want to use MacPython modules on MacOSX in unix-Python. */
--#define USE_TOOLBOX_OBJECT_GLUE 1
-+/* #undef USE_TOOLBOX_OBJECT_GLUE */
- 
- /* Define if a va_list is an array of some kind */
--#define VA_LIST_IS_ARRAY 1
-+/* #undef VA_LIST_IS_ARRAY */
- 
- /* Define if you want SIGFPE handled (see Include/pyfpe.h). */
- /* #undef WANT_SIGFPE_HANDLER */
-@@ -1076,7 +1076,7 @@
- /* #undef WANT_WCTYPE_FUNCTIONS */
- 
- /* Define if WINDOW in curses.h offers a field _flags. */
--/* #undef WINDOW_HAS_FLAGS */
-+#define WINDOW_HAS_FLAGS 1
- 
- /* Define if you want documentation strings in extension modules */
- #define WITH_DOC_STRINGS 1
-@@ -1084,10 +1084,10 @@
- /* Define if you want to use the new-style (Openstep, Rhapsody, MacOS) dynamic
-    linker (dyld) instead of the old-style (NextStep) dynamic linker (rld).
-    Dyld is necessary to support frameworks. */
--#define WITH_DYLD 1
-+/* #undef WITH_DYLD */
- 
- /* Define to 1 if libintl is needed for locale functions. */
--/* #undef WITH_LIBINTL */
-+#define WITH_LIBINTL 1
- 
- /* Define if you want to produce an OpenStep/Rhapsody framework (shared
-    library plus accessory files). */
-@@ -1097,7 +1097,7 @@
- #define WITH_PYMALLOC 1
- 
- /* Define if you want to compile in rudimentary thread support */
--/* #undef WITH_THREAD */
-+#define WITH_THREAD 1
- 
- /* Define to profile with the Pentium timestamp counter */
- /* #undef WITH_TSC */
-@@ -1152,7 +1152,7 @@
- /* #undef _POSIX_1_SOURCE */
- 
- /* Define to activate features from IEEE Stds 1003.1-2001 */
--/* #undef _POSIX_C_SOURCE */
-+#define _POSIX_C_SOURCE 200112L
- 
- /* Define to 1 if you need to in order for `stat' and other things to work. */
- /* #undef _POSIX_SOURCE */
-@@ -1161,7 +1161,7 @@
- /* #undef _POSIX_THREADS */
- 
- /* Define to force use of thread-safe errno, h_errno, and other functions */
--/* #undef _REENTRANT */
-+#define _REENTRANT 1
- 
- /* Define for Solaris 2.5.1 so the uint32_t typedef from <sys/synch.h>,
-    <pthread.h>, or <semaphore.h> is not used. If the typedef were allowed, the
-@@ -1174,10 +1174,10 @@
- /* #undef _UINT64_T */
- 
- /* Define to the level of X/Open that your system supports */
--/* #undef _XOPEN_SOURCE */
-+#define _XOPEN_SOURCE 600
- 
- /* Define to activate Unix95-and-earlier features */
--/* #undef _XOPEN_SOURCE_EXTENDED */
-+#define _XOPEN_SOURCE_EXTENDED 1
- 
- /* Define on FreeBSD to activate all library features */
- #define __BSD_VISIBLE 1

+ 16 - 0
scripts/reloc.sh

@@ -0,0 +1,16 @@
+#!/usr/bin/env bash
+# execute this after relocation of adk directory
+
+olddir=$(grep "^TOPDIR" prereq.mk |cut -d '=' -f 2)
+newdir=$(pwd)
+
+if [ "$olddir" != "$newdir" ];then
+	echo "adk directory relocated!"
+	echo "old directory: $olddir"
+	echo "new directory: $newdir"
+	sed -i -e "s#$olddir#$newdir#g" $(find target_* -name \*.pc|xargs)
+	sed -i -e "s#$olddir#$newdir#g" $(find target_* -name \*.la|xargs)
+	sed -i -e "s#$olddir#$newdir#g" $(find target_*/scripts -type f|xargs)
+	sed -i -e "s#$olddir#$newdir#" target_*/etc/ipkg.conf
+	sed -i -e "s#$olddir#$newdir#" prereq.mk
+fi

+ 1 - 1
toolchain/glibc/Makefile

@@ -17,6 +17,7 @@ ifeq ($(ADK_TARGET_NO_FPU),y)
 GLIBC_CONFOPTS+=	--without-fp
 endif
 
+GLIBC_MAKEOPTS+=	cross-compiling=yes
 ifeq (${ADK_MAKE_PARALLEL},y)
 GLIBC_MAKEOPTS+=	PARALLELMFLAGS="-j${ADK_MAKE_JOBS}"
 endif
@@ -41,7 +42,6 @@ $(WRKBUILD)/.headers: $(WRKBUILD)/.headers_configure
 	(cd $(GLIBC_BUILD_DIR_INITIAL); \
 		${GLIBC_ENV} \
 		$(MAKE) ${GLIBC_MAKEOPTS} \
-		cross-compiling=yes \
 		install-headers \
 	);
 	touch $(STAGING_TARGET_DIR)/usr/include/gnu/stubs.h

+ 135 - 0
toolchain/glibc/patches/tz.patch

@@ -0,0 +1,135 @@
+--- glibc-2.12.1/timezone/Makefile	2010-07-27 13:34:39.000000000 +0200
++++ glibc-2.12.1.orig/timezone/Makefile	2011-01-10 15:20:02.576150764 +0100
+@@ -69,13 +69,10 @@
+ 					 $(addprefix $(inst_zonedir)/, \
+ 						     $(posixrules-file)))
+ 
+-ifeq ($(cross-compiling),no)
+-# Don't try to install the zoneinfo files since we can't run zic.
+ install-others = $(addprefix $(inst_zonedir)/,$(zonenames) \
+ 					      $(zonenames:%=posix/%) \
+ 					      $(zonenames:%=right/%)) \
+ 		 $(installed-localtime-file) $(installed-posixrules-file)
+-endif
+ 
+ ifeq ($(have-ksh),yes)
+ install-others += $(inst_zonedir)/iso3166.tab $(inst_zonedir)/zone.tab
+@@ -106,18 +103,35 @@
+ 	   echo '$$(addprefix $$(inst_zonedir)/,$$($*-zones)): \'	    ;\
+ 	   echo '$$(foreach t,$$(tzbases),$$(addprefix $$(inst_zonedir)/,$$($$t-zones)))' ;\
+ 	 fi								    ;\
+-	 echo '$$(addprefix $$(dir $$(inst_zonedir))zone%/right/,$$($*-zones)): \' ;\
+-	 echo '$< $$(objpfx)zic leapseconds yearistype'			    ;\
+-	 echo '	$$(tzcompile)'						    ;\
+-	 echo '$$(addprefix $$(dir $$(inst_zonedir))zone%/posix/,$$($*-zones)): \' ;\
+-	 echo '$< $$(objpfx)zic /dev/null yearistype'			    ;\
+-	 echo '	$$(tzcompile)'						    ;\
+-	 echo '$$(addprefix $$(dir $$(inst_zonedir))zone%/,$$($*-zones)): \' ;\
+-	 echo '$< $$(objpfx)zic $$(leapseconds) yearistype'		    ;\
+-	 echo '	$$(tzcompile)'						    ;\
++	 echo '$$(addprefix $$(dir $$(inst_zonedir))zone%/right/,$$($*-zones)): \' ;) > $@.new
++
++ifeq (no,$(cross-compiling))
++	(echo '$< $$(objpfx)zic leapseconds yearistype'			    ;) >> $@.new
++else
++	(echo '$< $$(objpfx)cross-zic leapseconds yearistype'		    ;) >> $@.new
++endif
++
++	(echo '	$$(tzcompile)'						    ;\
++	 echo '$$(addprefix $$(dir $$(inst_zonedir))zone%/posix/,$$($*-zones)): \' ;) >> $@.new
++
++ifeq (no,$(cross-compiling))
++	(echo '$< $$(objpfx)zic /dev/null yearistype'			    ;) >> $@.new
++else
++	(echo '$< $$(objpfx)cross-zic /dev/null yearistype'		    ;) >> $@.new
++endif
++
++	(echo '	$$(tzcompile)'						    ;\
++	 echo '$$(addprefix $$(dir $$(inst_zonedir))zone%/,$$($*-zones)): \' ;) >> $@.new
++
++ifeq (no,$(cross-compiling))
++	(echo '$< $$(objpfx)zic $$(leapseconds) yearistype'		    ;) >> $@.new
++else
++	(echo '$< $$(objpfx)cross-zic $$(leapseconds) yearistype'	    ;) >> $@.new
++endif
++
++	(echo '	$$(tzcompile)'						    ;\
+ 	 echo 'endif'							    ;\
+-	 echo 'zonenames := $$(zonenames) $$($*-zones)'			    ;\
+-	) > $@.new
++	 echo 'zonenames := $$(zonenames) $$($*-zones)'			    ;) >> $@.new
+ 	mv $@.new $@
+ 
+ .PHONY: echo-zonenames
+@@ -128,7 +142,11 @@
+ # We have to use `-d $(inst_zonedir)' to explictly tell zic where to
+ # place the output files although $(zonedir) is compiled in.  But the
+ # user might have set $(install_root) on the command line of `make install'.
++ifeq (no,$(cross-compiling))
+ zic-cmd = $(built-program-cmd) -d $(inst_zonedir)
++else
++zic-cmd = $(objpfx)cross-zic -d $(inst_zonedir)
++endif
+ tzcompile = $(zic-cmd)$(target-zone-flavor) -L $(word 3,$^) \
+ 	    -y $(dir $(word 4,$^))$(notdir $(word 4,$^)) $<
+ 
+@@ -158,8 +176,17 @@
+ 	$(zic-cmd) -p $(posixrules)
+ endif
+ 
++zic-objs = zic.o ialloc.o scheck.o
++
++$(objpfx)zic: $(addprefix $(objpfx), $(zic-objs))
++
++$(addprefix $(objpfx)cross-,$(zic-objs)): $(objpfx)cross-%.o: %.c
++	gcc $< -c $(OUTPUT_OPTION) \
++		$(filter-out -DHAVE_GETTEXT,$(CFLAGS-$*.c)) \
++		$(CPPFLAGS-$*) -DCROSS_ZIC $(compile-mkdep-flags)
+ 
+-$(objpfx)zic: $(objpfx)scheck.o $(objpfx)ialloc.o
++$(objpfx)cross-zic: $(addprefix $(objpfx)cross-,$(zic-objs))
++	gcc $(addprefix $(objpfx)cross-,$(zic-objs)) -o $@
+ 
+ tz-cflags = -DTZDIR='"$(zonedir)"' \
+ 	    -DTZDEFAULT='"$(localtime-file)"' \
+@@ -176,10 +203,17 @@
+ # Don't add leapseconds here since test-tz made checks that work only without
+ # leapseconds.
+ testdata = $(objpfx)testdata
++ifeq (no,$(cross-compiling))
+ define build-testdata
+ GCONV_PATH=${common-objpfx}iconvdata LANGUAGE=C LC_ALL=C \
+   $(built-program-cmd) -d $(testdata) -y ./yearistype $<
+ endef
++else
++define build-testdata
++LANGUAGE=C LC_ALL=C \
++  $(objpfx)cross-zic -d $(testdata) -y ./yearistype $<
++endef
++endif
+ 
+ $(objpfx)test-tz.out: $(addprefix $(testdata)/, America/New_York Etc/UTC UTC)
+ $(objpfx)tst-timezone.out: $(addprefix $(testdata)/, \
+@@ -192,7 +226,11 @@
+ tst-timezone-ENV = TZDIR=$(testdata)
+ 
+ # Note this must come second in the deps list for $(built-program-cmd) to work.
++ifeq (no,$(cross-compiling))
+ zic-deps = $(objpfx)zic $(leapseconds) yearistype
++else
++zic-deps = $(objpfx)cross-zic $(objpfx)zic $(leapseconds) yearistype
++endif
+ 
+ $(testdata)/America/New_York: northamerica $(zic-deps)
+ 	$(build-testdata)
+@@ -214,7 +252,9 @@
+ 
+ $(objpfx)tzselect: tzselect.ksh $(common-objpfx)config.make
+ 	sed -e 's%@KSH@%$(KSH)%g' \
+-	    -e 's%@TZDIR@%$(zonedir)%g' < $< > $@.new
++	    -e 's%@TZDIR@%$(zonedir)%g' \
++	    -e 's%@PKGVERSION@%$(PKGVERSION)%g' \
++	    -e 's%@REPORT_BUGS_TO@%$(REPORT_BUGS_TO)%g' < $< > $@.new
+ 	chmod 555 $@.new
+ 	mv -f $@.new $@
+